diff --git a/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java b/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
index f0f811d09..c523ac235 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/options/data/OptionsPages.java
@@ -4,7 +4,6 @@ import com.mojang.logging.LogUtils;
 import com.mojang.nbt.NbtIo;
 import net.betterthanadventure.utils.DataDumper;
 import net.minecraft.client.Minecraft;
-import net.minecraft.client.enums.EnumGPUVendor;
 import net.minecraft.client.gui.ScreenControllerSetup;
 import net.minecraft.client.gui.ScreenFontTest;
 import net.minecraft.client.gui.ScreenHudDesigner;
@@ -13,8 +12,8 @@ import net.minecraft.client.gui.ScreenTextureViewer;
 import net.minecraft.client.gui.achievements.ScreenAchievements;
 import net.minecraft.client.gui.modelviewer.ScreenModelViewer;
 import net.minecraft.client.gui.nbteditor.ScreenNBTEditor;
+import net.minecraft.client.gui.options.ScreenOptions;
 import net.minecraft.client.gui.options.components.*;
-import net.minecraft.client.option.enums.LightmapStyle;
 import net.minecraft.client.player.controller.PlayerControllerSP;
 import net.minecraft.client.sound.SoundEngine;
 import net.minecraft.client.util.helper.FileOpener;
@@ -27,17 +26,16 @@ import net.minecraft.core.achievement.stat.StatList;
 import net.minecraft.core.block.Blocks;
 import net.minecraft.core.item.ItemStack;
 import net.minecraft.core.item.Items;
+import org.jetbrains.annotations.NotNull;
 import org.useless.seedviewer.SeedViewerMain;
 import paulscode.sound.SoundSystem;
 
-import javax.management.RuntimeErrorException;
 import java.io.File;
 import java.io.IOException;
 import java.util.Collections;
 
 
-public abstract class OptionsPages
-{
+public abstract class OptionsPages {
     private static final Minecraft mc = Minecraft.getMinecraft();
     private static boolean hasInit = false;
     public static OptionsPage GENERAL;
@@ -51,14 +49,12 @@ public abstract class OptionsPages
     public static OptionsPage SEARCH;
     public static OptionsPage DEBUG;
 
-    public static OptionsPage register(OptionsPage page)
-    {
+    public static OptionsPage register(OptionsPage page) {
         OptionsPageRegistry.getInstance().register(page);
         return page;
     }
 
-    public static void init()
-    {
+    public static void init() {
         if (hasInit) return;
         hasInit = true;
 
@@ -84,7 +80,7 @@ public abstract class OptionsPages
                 .withComponent(new BooleanOptionComponent(mc.gameSettings.armorDurabilityOverlay))
                 .withComponent(new BooleanOptionComponent(mc.gameSettings.heldItemCountOverlay))
                 .withComponent(new BooleanOptionComponent(mc.gameSettings.heldItemTooltips))
-                .withComponent(new ToggleableOptionComponent(mc.gameSettings.itemDescriptions))
+                .withComponent(new ToggleableOptionComponent<>(mc.gameSettings.itemDescriptions))
                 .withComponent(new BooleanOptionComponent(mc.gameSettings.hideUndiscoveredItems))
                 .withComponent(new BooleanOptionComponent(mc.gameSettings.dynamicCursor))
                 .withComponent(new BooleanOptionComponent(mc.gameSettings.musicToasts))
@@ -133,56 +129,48 @@ public abstract class OptionsPages
             )
         );
 
-        final OptionsComponent lightmapComponent = new ToggleableOptionComponent<>(mc.gameSettings.lightmapStyle);
-
         VIDEO = register(new OptionsPage("gui.options.page.video.title", new ItemStack(Items.FLAG))
-            .withComponent(new OptionsCategory("gui.options.page.video.category.graphics")
-                .withComponent(new BooleanOptionComponent(mc.gameSettings.fullscreen))
-                .withComponent(new BooleanOptionComponent(mc.gameSettings.borderlessFullscreen))
-                .withComponent(new ToggleableOptionComponent<>(mc.gameSettings.renderScale))
-                .withComponent(new ToggleableOptionComponent<>(mc.gameSettings.fancyGraphics))
-                .withComponent(new ToggleableOptionComponent<>(mc.gameSettings.renderDistance))
-                .withComponent(new BooleanOptionComponent(mc.gameSettings.ambientOcclusion))
-                .withComponent(new BooleanOptionComponent(mc.gameSettings.connectedGlass))
-                .withComponent(new ToggleableOptionComponent<>(mc.gameSettings.mipmapLevels))
-                .withComponent(new ToggleableOptionComponent<>(mc.gameSettings.mipmapType))
-                .withComponent(new ToggleableOptionComponent<>(mc.gameSettings.colorblindnessFix))
-            )
-            .withComponent(new OptionsCategory("gui.options.page.video.category.performance")
-                .withComponent(new BooleanOptionComponent(mc.gameSettings.enableVsync))
-                .withComponent(new FramerateOptionComponent(mc.gameSettings.customFpsLimit))
-                .withComponent(new BooleanOptionComponent(mc.gameSettings.advancedOpenGL))
-            )
-            .withComponent(new OptionsCategory("gui.options.page.video.category.post_processing")
-                .withComponent(new FloatOptionComponent(mc.gameSettings.gamma))
-                .withComponent(new FloatOptionComponent(mc.gameSettings.colorCorrection))
-                .withComponent(new FloatOptionComponent(mc.gameSettings.fxaa))
-                .withComponent(new ToggleableOptionComponent<>(mc.gameSettings.bloom))
-                .withComponent(new BooleanOptionComponent(mc.gameSettings.heatHaze))
-            )
-            .withComponent(new OptionsCategory("gui.options.page.video.category.visuals")
-                .withComponent(Minecraft.GPU_VENDOR == EnumGPUVendor.INTEL ? null : lightmapComponent)
-                .withComponent(new FloatOptionComponent(mc.gameSettings.brightness){
-                    @Override
-                    public void render(final int x, final int y, final int width, final int relativeMouseX, final int relativeMouseY) {
-                        this.slider.enabled = mc.gameSettings.lightmapStyle.value != LightmapStyle.DISABLED;
-                        super.render(x, y, width, relativeMouseX, relativeMouseY);
-                    }
-                })
-                .withComponent(new BooleanOptionComponent(mc.gameSettings.fovModification))
-                .withComponent(new BooleanOptionComponent(mc.gameSettings.screenMotionEffects))
-                .withComponent(new BooleanOptionComponent(mc.gameSettings.fog))
-                .withComponent(new BooleanOptionComponent(mc.gameSettings.biomeWater))
-                .withComponent(new BooleanOptionComponent(mc.gameSettings.treeShadows))
-                .withComponent(new BooleanOptionComponent(mc.gameSettings.vignette))
-                .withComponent(new BooleanOptionComponent(mc.gameSettings.items3D))
-                .withComponent(new BooleanOptionComponent(mc.gameSettings.clouds))
-                .withComponent(new FloatOptionComponent(mc.gameSettings.cloudHeight, -0.5f, 1f))
-                .withComponent(new FloatOptionComponent(mc.gameSettings.entityRenderDistance, 0.1f, 3f))
-                .withComponent(new BooleanOptionComponent(mc.gameSettings.aurora))
-                .withComponent(new BooleanOptionComponent(mc.gameSettings.slimeParticles))
-                .withComponent(new FloatOptionComponent(mc.gameSettings.blockOutlineWidth))
-            )
+                .withComponent(new OptionsCategory("gui.options.page.video.category.graphics")
+                    .withComponent(new BooleanOptionComponent(mc.gameSettings.fullscreen))
+                    .withComponent(new BooleanOptionComponent(mc.gameSettings.borderlessFullscreen))
+                    .withComponent(new ToggleableOptionComponent<>(mc.gameSettings.renderScale))
+                    .withComponent(new ToggleableOptionComponent<>(mc.gameSettings.fancyGraphics))
+                    .withComponent(new ToggleableOptionComponent<>(mc.gameSettings.renderDistance))
+                    .withComponent(new BooleanOptionComponent(mc.gameSettings.ambientOcclusion))
+                    .withComponent(new BooleanOptionComponent(mc.gameSettings.connectedGlass))
+                    .withComponent(new ToggleableOptionComponent<>(mc.gameSettings.mipmapLevels))
+                    .withComponent(new ToggleableOptionComponent<>(mc.gameSettings.mipmapType))
+                    .withComponent(new ToggleableOptionComponent<>(mc.gameSettings.colorblindnessFix))
+                )
+                .withComponent(new OptionsCategory("gui.options.page.video.category.performance")
+                        .withComponent(new BooleanOptionComponent(mc.gameSettings.enableVsync))
+                        .withComponent(new FramerateOptionComponent(mc.gameSettings.customFpsLimit))
+//                .withComponent(new BooleanOptionComponent(mc.gameSettings.advancedOpenGL))
+                )
+                .withComponent(new OptionsCategory("gui.options.page.video.category.post_processing")
+                    .withComponent(new FloatOptionComponent(mc.gameSettings.gamma))
+                    .withComponent(new FloatOptionComponent(mc.gameSettings.colorCorrection))
+                    .withComponent(new FloatOptionComponent(mc.gameSettings.fxaa))
+                    .withComponent(new ToggleableOptionComponent<>(mc.gameSettings.bloom))
+                    .withComponent(new BooleanOptionComponent(mc.gameSettings.heatHaze))
+                )
+                .withComponent(new OptionsCategory("gui.options.page.video.category.visuals")
+                    .withComponent(new ToggleableOptionComponent<>(mc.gameSettings.lightmapStyle))
+                    .withComponent(new FloatOptionComponent(mc.gameSettings.brightness))
+                    .withComponent(new BooleanOptionComponent(mc.gameSettings.fovModification))
+                    .withComponent(new BooleanOptionComponent(mc.gameSettings.screenMotionEffects))
+                    .withComponent(new BooleanOptionComponent(mc.gameSettings.fog))
+                    .withComponent(new BooleanOptionComponent(mc.gameSettings.biomeWater))
+                    .withComponent(new BooleanOptionComponent(mc.gameSettings.treeShadows))
+                    .withComponent(new BooleanOptionComponent(mc.gameSettings.vignette))
+                    .withComponent(new BooleanOptionComponent(mc.gameSettings.items3D))
+                    .withComponent(new BooleanOptionComponent(mc.gameSettings.clouds))
+                    .withComponent(new FloatOptionComponent(mc.gameSettings.cloudHeight, -0.5f, 1f))
+                    .withComponent(new FloatOptionComponent(mc.gameSettings.entityRenderDistance, 0.1f, 3f))
+                    .withComponent(new BooleanOptionComponent(mc.gameSettings.aurora))
+                    .withComponent(new BooleanOptionComponent(mc.gameSettings.slimeParticles))
+                    .withComponent(new FloatOptionComponent(mc.gameSettings.blockOutlineWidth))
+                )
         );
 
         CONTROLS = register(new OptionsPage("gui.options.page.controls.title", new ItemStack(Items.BOAT))
@@ -301,7 +289,7 @@ public abstract class OptionsPages
                 .withComponent(new BooleanOptionComponent(mc.gameSettings.customLightmap))
                 .withComponent(new BooleanOptionComponent(mc.gameSettings.enableHolidayTextures))
             )
-            .withComponent(new ShortcutComponent("gui.options.page.asset_packs.button.apply", () -> mc.texturePackList.refreshIfReady()))
+            .withComponent(new ShortcutComponent("gui.options.page.asset_packs.button.apply", mc.texturePackList::refreshIfReady))
             .withComponent(new OptionsCategory("gui.options.page.asset_packs.category.asset_packs.selected")
                 .withComponent(new SelectedTexturePackListComponent())
             )
@@ -339,38 +327,38 @@ public abstract class OptionsPages
                 .withComponent(new KeyBindingComponent(mc.gameSettings.keyLoadChunksQuickly))
             )
             .withComponent(new OptionsCategory("gui.options.page.debug.category.settings")
-                .withComponent(new BooleanOptionComponent(mc.gameSettings.developerMode))
-                .withComponent(new BooleanOptionComponent(mc.gameSettings.playerDevModel))
-                .withComponent(new BooleanOptionComponent(mc.gameSettings.viewSupportMode))
-                .withComponent(new BooleanOptionComponent(mc.gameSettings.alphaMenu))
-                .withComponent(new BooleanOptionComponent(mc.gameSettings.lockCamera))
-                .withComponent(new BooleanOptionComponent(mc.gameSettings.showDebugScreen))
-                .withComponent(new BooleanOptionComponent(mc.gameSettings.showFrameTimes))
-                .withComponent(new BooleanOptionComponent(mc.gameSettings.showChunkBorders))
-                .withComponent(new BooleanOptionComponent(mc.gameSettings.showCollisionBoxes))
-                .withComponent(new BooleanOptionComponent(mc.gameSettings.showItemDebugInfo))
-                .withComponent(new BooleanOptionComponent(mc.gameSettings.disableCrashHandler))
-                .withComponent(new BooleanOptionComponent(mc.gameSettings.startInFullscreen))
-                .withComponent(new BooleanOptionComponent(mc.gameSettings.disableShaders))
-                .withComponent(Minecraft.GPU_VENDOR == EnumGPUVendor.INTEL ? lightmapComponent : null)
-                .withComponent(new BooleanOptionComponent(mc.gameSettings.loadAllSounds))
-                .withComponent(new BooleanOptionComponent(mc.gameSettings.allowSoundOverrides))
-                .withComponent(new BooleanOptionComponent(mc.gameSettings.downloadSoundfiles))
-                .withComponent(new BooleanOptionComponent(mc.gameSettings.enableDevResourceLoading))
-                .withComponent(new BooleanOptionComponent(mc.gameSettings.devModels))
-                .withComponent(new BooleanOptionComponent(mc.gameSettings.enableMultiDrawRendering))
-                .withComponent(new ToggleableOptionComponent<>(mc.gameSettings.enableThreadedChunkProvider))
-                .withComponent(new BooleanOptionComponent(mc.gameSettings.doJCECheck))
+                    .withComponent(new BooleanOptionComponent(mc.gameSettings.developerMode))
+                    .withComponent(new BooleanOptionComponent(mc.gameSettings.playerDevModel))
+                    .withComponent(new BooleanOptionComponent(mc.gameSettings.viewSupportMode))
+                    .withComponent(new BooleanOptionComponent(mc.gameSettings.alphaMenu))
+                    .withComponent(new BooleanOptionComponent(mc.gameSettings.lockCamera))
+                    .withComponent(new BooleanOptionComponent(mc.gameSettings.showDebugScreen))
+                    .withComponent(new BooleanOptionComponent(mc.gameSettings.showFrameTimes))
+                    .withComponent(new BooleanOptionComponent(mc.gameSettings.showChunkBorders))
+                    .withComponent(new BooleanOptionComponent(mc.gameSettings.showCollisionBoxes))
+                    .withComponent(new BooleanOptionComponent(mc.gameSettings.showItemDebugInfo))
+                    .withComponent(new BooleanOptionComponent(mc.gameSettings.disableCrashHandler))
+                    .withComponent(new BooleanOptionComponent(mc.gameSettings.startInFullscreen))
+//                .withComponent(new BooleanOptionComponent(mc.gameSettings.disableShaders))
+                    .withComponent(new BooleanOptionComponent(mc.gameSettings.loadAllSounds))
+                    .withComponent(new BooleanOptionComponent(mc.gameSettings.allowSoundOverrides))
+                    .withComponent(new BooleanOptionComponent(mc.gameSettings.downloadSoundfiles))
+                    .withComponent(new BooleanOptionComponent(mc.gameSettings.enableDevResourceLoading))
+                    .withComponent(new BooleanOptionComponent(mc.gameSettings.devModels))
+//                .withComponent(new BooleanOptionComponent(mc.gameSettings.enableMultiDrawRendering))
+                    .withComponent(new ToggleableOptionComponent<>(mc.gameSettings.enableThreadedChunkProvider))
+                    .withComponent(new BooleanOptionComponent(mc.gameSettings.doJCECheck))
             )
             .withComponent(new OptionsCategory("gui.options.page.debug.category.utility")
                 .withComponent(new ShortcutComponent("gui.options.page.debug.button.open.model_viewer", () -> {
                                    mc.playerController = new PlayerControllerSP(mc);
                                    mc.changeWorld(WorldClient.EMPTY_WORLD, "Loading Model Viewer");
-                                   mc.displayScreen(new ScreenModelViewer());}) {
+                                   mc.displayScreen(new ScreenModelViewer());
+                               }) {
                                    @Override
-                                   public void render(final int x, final int y, final int width, final int relativeMouseX, final int relativeMouseY) {
+                                   public void render(@NotNull ScreenOptions screenOptions, final int x, final int y, final int width, final int relativeMouseX, final int relativeMouseY) {
                                        this.button.enabled = mc.currentWorld == null;
-                                       super.render(x, y, width, relativeMouseX, relativeMouseY);
+                                       super.render(screenOptions, x, y, width, relativeMouseX, relativeMouseY);
                                    }
                                }
                 )
@@ -394,7 +382,7 @@ public abstract class OptionsPages
                         throw new RuntimeException(e);
                     }
                 }))
-                .withComponent(new ShortcutComponent("gui.options.page.debug.button.open.datadumper", () ->{
+                .withComponent(new ShortcutComponent("gui.options.page.debug.button.open.datadumper", () -> {
                     DataDumper.main(new String[0]);
                     FileOpener.open(new File(mc.getMinecraftDir(), "infodump"));
                     Global.accessor = mc;
@@ -414,23 +402,23 @@ public abstract class OptionsPages
                     mc.currentWorld.getLevelData().setCheatsEnabled(true);
                 }) {
                     @Override
-                    public void render(final int x, final int y, final int width, final int relativeMouseX, final int relativeMouseY) {
+                    public void render(@NotNull ScreenOptions screenOptions, final int x, final int y, final int width, final int relativeMouseX, final int relativeMouseY) {
                         this.button.enabled = (mc.currentWorld != null && !mc.currentWorld.isClientSide);
-                        super.render(x, y, width, relativeMouseX, relativeMouseY);
+                        super.render(screenOptions, x, y, width, relativeMouseX, relativeMouseY);
                     }
                 })
                 .withComponent(new ShortcutComponent("gui.options.page.debug.button.wipestats", () -> {
                     mc.statsCounter.wipe("I want to delete all the saved stats");
                 }))
                 .withComponent(new ShortcutComponent("gui.options.page.debug.button.unlockedall", () -> {
-                    for (final Stat stat : StatList.getAllStats()){
+                    for (final Stat stat : StatList.getAllStats()) {
                         mc.thePlayer.addStat(stat, mc.thePlayer.getStat(stat) == 0 ? 1 : 0);
                     }
                 }) {
                     @Override
-                    public void render(int x, int y, int width, int relativeMouseX, int relativeMouseY) {
+                    public void render(@NotNull ScreenOptions screenOptions, int x, int y, int width, int relativeMouseX, int relativeMouseY) {
                         this.button.enabled = (mc.thePlayer != null);
-                        super.render(x, y, width, relativeMouseX, relativeMouseY);
+                        super.render(screenOptions, x, y, width, relativeMouseX, relativeMouseY);
                     }
                 })
                 .withComponent(new ShortcutComponent("gui.options.page.debug.button.crash.soft", () -> {
diff --git a/game/client/src/main/java/net/minecraft/client/gui/paged/ScreenPaged.java b/game/client/src/main/java/net/minecraft/client/gui/paged/ScreenPaged.java
index a3659c326..4a94b27a9 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/paged/ScreenPaged.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/paged/ScreenPaged.java
@@ -4,16 +4,17 @@ import net.minecraft.client.gui.ButtonElement;
 import net.minecraft.client.gui.ItemElement;
 import net.minecraft.client.gui.Screen;
 import net.minecraft.client.render.Scissor;
-import net.minecraft.client.render.tessellator.Tessellator;
+import net.minecraft.client.render.renderer.BlendFactor;
+import net.minecraft.client.render.renderer.GLRenderer;
+import net.minecraft.client.render.renderer.Shaders;
+import net.minecraft.client.render.renderer.State;
+import net.minecraft.client.render.tessellator.TessellatorGeneral;
 import net.minecraft.core.lang.I18n;
 import net.minecraft.core.sound.SoundCategory;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
 import org.lwjgl.input.Keyboard;
 import org.lwjgl.input.Mouse;
-import org.lwjgl.opengl.GL11;
-
-import static org.lwjgl.opengl.GL11.*;
 
 public class ScreenPaged
     extends Screen {
@@ -190,7 +191,7 @@ public class ScreenPaged
     }
 
     public void handleScroll(int mx, int my, float partialTick) {
-        if (mx > this.leftWidth + SEPARATOR_WIDTH + PADDING && mx < this.width - rightOffset) {
+        if (mx > this.leftWidth + SEPARATOR_WIDTH + PADDING && mx < this.width - this.rightOffset) {
             if (Keyboard.isKeyDown(Keyboard.KEY_LCONTROL) || Keyboard.isKeyDown(Keyboard.KEY_RCONTROL)) {
                 this.scrollRightPanel(Mouse.getDWheel() / -0.01f);
             } else {
@@ -212,7 +213,7 @@ public class ScreenPaged
         handleScroll(mx, my, renderPartialTicks);
 
         this.leftWidth = (int) (this.width * 0.25f);
-        this.pageWidth = this.width - (this.leftWidth + SEPARATOR_WIDTH + (PADDING * 2)) - rightOffset;
+        this.pageWidth = this.width - (this.leftWidth + SEPARATOR_WIDTH + (PADDING * 2)) - this.rightOffset;
         final @NotNull I18n i18n = I18n.getInstance();
 
         this.renderBackground();
@@ -242,37 +243,37 @@ public class ScreenPaged
 
         // Draw shadows
         if (this.mc.currentWorld == null) {
-            final Tessellator tessellator = Tessellator.instance;
-            GL11.glDisable(GL_DEPTH_TEST);
+//            GL11.glDisable(GL_ALPHA_TEST);
+//            GL11.glShadeModel(GL_SMOOTH);
+
+            GLRenderer.pushFrame();
+            GLRenderer.disableState(State.DEPTH_TEST);
+            GLRenderer.enableState(State.BLEND);
+            GLRenderer.setBlendFunc(BlendFactor.SRC_ALPHA, BlendFactor.ONE_MINUS_SRC_ALPHA);
+            GLRenderer.setShader(Shaders.COLOR);
             final int shadowSize = 4;
-            GL11.glEnable(GL_BLEND);
-            GL11.glBlendFunc(GL_SRC_ALPHA, GL_ONE_MINUS_SRC_ALPHA);
-            GL11.glDisable(GL_ALPHA_TEST);
-            GL11.glShadeModel(GL_SMOOTH);
-            GL11.glDisable(GL_TEXTURE_2D);
-
+            final TessellatorGeneral tessellator = GLRenderer.getTessellator();
             tessellator.startDrawingQuads();
-            tessellator.setColorRGBA_I(0, 0);
+            tessellator.setColor2i(0, 0);
             tessellator.addVertexWithUV(0, this.top + shadowSize, 0.0D, 0.0D, 1.0D);
             tessellator.addVertexWithUV(this.width, this.top + shadowSize, 0.0D, 1.0D, 1.0D);
-            tessellator.setColorRGBA_I(0, 255);
+            tessellator.setColor2i(0, 255);
             tessellator.addVertexWithUV(this.width, this.top, 0.0D, 1.0D, 0.0D);
             tessellator.addVertexWithUV(0, this.top, 0.0D, 0.0D, 0.0D);
             tessellator.draw();
 
             tessellator.startDrawingQuads();
-            tessellator.setColorRGBA_I(0, 255);
+            tessellator.setColor2i(0, 255);
             tessellator.addVertexWithUV(0, this.bottom, 0.0D, 0.0D, 1.0D);
             tessellator.addVertexWithUV(this.width, this.bottom, 0.0D, 1.0D, 1.0D);
-            tessellator.setColorRGBA_I(0, 0);
+            tessellator.setColor2i(0, 0);
             tessellator.addVertexWithUV(this.width, this.bottom - shadowSize, 0.0D, 1.0D, 0.0D);
             tessellator.addVertexWithUV(0, this.bottom - shadowSize, 0.0D, 0.0D, 0.0D);
             tessellator.draw();
+            GLRenderer.popFrame();
 
-            GL11.glEnable(GL_TEXTURE_2D);
-            GL11.glShadeModel(GL_FLAT);
-            GL11.glEnable(GL_ALPHA_TEST);
-            GL11.glDisable(GL_BLEND);
+//            GL11.glShadeModel(GL_FLAT);
+//            GL11.glEnable(GL_ALPHA_TEST);
         }
 
         this.overlayBackground(this.leftWidth, this.leftWidth + SEPARATOR_WIDTH, this.top, this.bottom);
@@ -291,9 +292,7 @@ public class ScreenPaged
 
         if (scrollBarHeightPercent > 1.0f) return;
 
-        glDisable(GL_TEXTURE_2D);
-
-        final int scrollBarX = this.width - 6 - rightOffset;
+        final int scrollBarX = this.width - 6 - this.rightOffset;
 
         int scrollBarHeightPx = (int) (scrollBarHeightPercent * this.rightScrollRegionHeight);
         if (scrollBarHeightPx < 32) {
@@ -304,18 +303,18 @@ public class ScreenPaged
 
         final int scrollBarY = (int) (this.top + (this.rightScrollRegionHeight - scrollBarHeightPx) * scrollPercent);
 
-        final @NotNull Tessellator t = Tessellator.instance;
-
+        GLRenderer.pushFrame();
+        GLRenderer.setShader(Shaders.COLOR);
+        final @NotNull TessellatorGeneral t = GLRenderer.getTessellator();
         t.startDrawingQuads();
-        t.setColorOpaque(0, 0, 0);
+        t.setColorOpaque3i(0, 0, 0);
         t.drawRectangle(scrollBarX, this.top, 6, this.rightScrollRegionHeight);
-        t.setColorRGBA_I(0x808080, 255);
+        t.setColor2i(0x808080, 255);
         t.drawRectangle(scrollBarX, scrollBarY, 6, scrollBarHeightPx);
-        t.setColorRGBA_I(0xc0c0c0, 255);
+        t.setColor2i(0xc0c0c0, 255);
         t.drawRectangle(scrollBarX + 1, scrollBarY, 5, scrollBarHeightPx - 1);
         t.draw();
-
-        glEnable(GL_TEXTURE_2D);
+        GLRenderer.popFrame();
 
         if (this.clickX != null && this.clickY != null) {
             if (this.clickX >= scrollBarX && this.clickY >= this.top && this.clickX <= scrollBarX + 6 && this.clickY < this.bottom) {
@@ -336,8 +335,6 @@ public class ScreenPaged
 
         if (scrollBarHeightPercent > 1.0f) return;
 
-        glDisable(GL_TEXTURE_2D);
-
         final int scrollBarX = this.leftWidth - 6;
 
         int scrollBarHeightPx = (int) (scrollBarHeightPercent * this.leftScrollRegionHeight);
@@ -349,18 +346,19 @@ public class ScreenPaged
 
         final int scrollBarY = (int) (this.top + (this.leftScrollRegionHeight - scrollBarHeightPx) * scrollPercent);
 
-        final @NotNull Tessellator t = Tessellator.instance;
+        GLRenderer.pushFrame();
+        GLRenderer.setShader(Shaders.COLOR);
+        final @NotNull TessellatorGeneral t = GLRenderer.getTessellator();
 
         t.startDrawingQuads();
-        t.setColorOpaque(0, 0, 0);
+        t.setColorOpaque3i(0, 0, 0);
         t.drawRectangle(scrollBarX, this.top, 6, this.leftScrollRegionHeight);
-        t.setColorRGBA_I(0x808080, 255);
+        t.setColor2i(0x808080, 255);
         t.drawRectangle(scrollBarX, scrollBarY, 6, scrollBarHeightPx);
-        t.setColorRGBA_I(0xc0c0c0, 255);
+        t.setColor2i(0xc0c0c0, 255);
         t.drawRectangle(scrollBarX + 1, scrollBarY, 5, scrollBarHeightPx - 1);
         t.draw();
-
-        glEnable(GL_TEXTURE_2D);
+        GLRenderer.popFrame();
 
         if (this.clickX != null && this.clickY != null) {
             if (this.clickX >= scrollBarX && this.clickY >= this.top && this.clickX <= scrollBarX + 6 && this.clickY < this.bottom) {
@@ -447,12 +445,12 @@ public class ScreenPaged
         super.renderBackground();
 
         if (this.mc.currentWorld == null) {
-            final @NotNull Tessellator tessellator = Tessellator.instance;
+            final @NotNull TessellatorGeneral tessellator = GLRenderer.getTessellator();
             this.mc.textureManager.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
-            GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
+            GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 1.0F);
             final float scale = 32F;
             tessellator.startDrawingQuads();
-            tessellator.setColorOpaque_I(0x202020);
+            tessellator.setColorOpaque1i(0x202020);
 
             tessellator.addVertexWithUV(0, this.bottom, 0.0D, 0, (float) (this.bottom + (int) this.rightScrollAmount) / scale);
             tessellator.addVertexWithUV(this.width, this.bottom, 0.0D, (float) this.width / scale, (float) (this.bottom + (int) this.rightScrollAmount) / scale);
@@ -474,15 +472,15 @@ public class ScreenPaged
 
     protected void overlayBackground(final int minX, final int maxX, final int minY, final int maxY) {
         if (this.mc.currentWorld == null) {
-            final @NotNull Tessellator tessellator = Tessellator.instance;
+            final @NotNull TessellatorGeneral tessellator = GLRenderer.getTessellator();
             this.mc.textureManager.loadTexture("/assets/minecraft/textures/gui/background.png").bind();
-            GL11.glColor4f(1.0F, 1.0F, 1.0F, 1.0F);
+            GLRenderer.setColor4f(1.0F, 1.0F, 1.0F, 1.0F);
             final float scale = 32F;
             tessellator.startDrawingQuads();
-            tessellator.setColorOpaque_I(0x404040);
+            tessellator.setColorOpaque1i(0x404040);
             tessellator.addVertexWithUV(minX, maxY, 0.0D, (float) minX / scale, (float) maxY / scale);
             tessellator.addVertexWithUV(maxX, maxY, 0.0D, (float) maxX / scale, (float) maxY / scale);
-            tessellator.setColorOpaque_I(0x404040);
+            tessellator.setColorOpaque1i(0x404040);
             tessellator.addVertexWithUV(maxX, minY, 0.0D, (float) maxX / scale, (float) minY / scale);
             tessellator.addVertexWithUV(minX, minY, 0.0D, (float) minX / scale, (float) minY / scale);
             tessellator.draw();
diff --git a/game/client/src/main/java/net/minecraft/client/gui/popup/LabelComponent.java b/game/client/src/main/java/net/minecraft/client/gui/popup/LabelComponent.java
index 51724cd09..50072f4f3 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/popup/LabelComponent.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/popup/LabelComponent.java
@@ -2,7 +2,6 @@ package net.minecraft.client.gui.popup;
 
 import net.minecraft.client.Minecraft;
 import net.minecraft.client.render.font.FontRenderer;
-import net.minecraft.client.render.tessellator.Tessellator;
 import org.jetbrains.annotations.NotNull;
 
 public class LabelComponent
@@ -26,6 +25,6 @@ public class LabelComponent
     @Override
     public void render(final int x, final int y, final int mouseX, final int mouseY) {
         final int middle = (x - PopupScreen.HORIZONTAL_MARGIN) + this.getWidth() / 2;
-        this.fontRenderer.renderCentered(Tessellator.instance, this.text, middle, y).setShadow().setColor(this.color).call();
+        this.fontRenderer.renderCentered(this.text, middle, y).setShadow().setColor(this.color).call();
     }
 }
